from transpiler.utils import UnsupportedNodeError


class NodeVisitorSeq:
    def visit(self, node):
        """Visit a node."""
        if type(node) == list:
            for n in node:
                self.visit(n)
        else:
            for parent in node.__class__.__mro__:
                if visitor := getattr(self, 'visit_' + parent.__name__, None):
                    return visitor(node)
            else:
                self.missing_impl(node)

    def missing_impl(self, node):
        raise UnsupportedNodeError(node)
